Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Array_Iterator Class Template Reference

Implement an iterator over an ACE_Array. More...

`#include <Array_Base.h>`

Collaboration diagram for ACE_Array_Iterator:

[legend]
List of all members.

## Public Methods
| ACE_Array_Iterator (ACE_Array_Base<T> &)
int | next (T *&next_item)
| Pass back the <next_item> that hasn't been seen in the Array. Returns 0 when all items have been seen, else 1.
int | advance (void)
| Move forward by one element in the Array. Returns 0 when all the items in the Array have been seen, else 1.
int | done (void) const
| Returns 1 when all items have been seen, else 0.
void | dump (void) const
| Dump the state of an object.
## Public Attributes
| ACE_ALLOC_HOOK_DECLARE
| Declare the dynamic allocation hooks.
## Private Attributes
size_t | current_
| Pointer to the current item in the iteration.
ACE_Array_Base<T>& | array_
| Pointer to the Array we're iterating over.

## Detailed Description

### template<class T> template class ACE_Array_Iterator

Implement an iterator over an ACE_Array.

This iterator is safe in the face of array element deletions. But it is NOT safe if the array is resized (via the ACE_Array assignment operator) during iteration. That would be very odd, and dangerous.

## Constructor & Destructor Documentation

template<classT>
ACE_INLINE ACE_Array_Iterator< T >::ACE_Array_Iterator<T> ( | ACE_Array_Base< T >& a )

## Member Function Documentation

template<classT>
ACE_INLINE int ACE_Array_Iterator< T >::advance ( | void )

| Move forward by one element in the Array. Returns 0 when all the items in the Array have been seen, else 1.

template<classT>
ACE_INLINE int ACE_Array_Iterator< T >::done ( | void ) const

| Returns 1 when all items have been seen, else 0.

template<classT>
ACE_INLINE void ACE_Array_Iterator< T >::dump ( | void ) const

| Dump the state of an object.

template<classT>
int ACE_Array_Iterator<T>::next ( | T *& next_item )

| Pass back the <next_item> that hasn't been seen in the Array. Returns 0 when all items have been seen, else 1.

## Member Data Documentation

template<classT>
ACE_Array_Iterator<T>::ACE_ALLOC_HOOK_DECLARE

| Declare the dynamic allocation hooks.

template<classT>
ACE_Array_Base< T >& ACE_Array_Iterator<T>::array_`[private]`

| Pointer to the Array we're iterating over.

template<classT>
size_t ACE_Array_Iterator<T>::current_`[private]`

| Pointer to the current item in the iteration.

The documentation for this class was generated from the following files:

- Array_Base.h
- Array_Base.cpp
- Array_Base.inl